
Specification inference is a
technique that uses static analysis to synthesize formal specifications in order to
capture some properties of a given program.
HIP infers specification to capture the shape of the manipulating heap regions (to ensure memory safety) as well as
 functional
properties (e.g., constraints over pure variables) and non-functional properties (e..g, termination and non-termination) for
heap-based
programs.
The specification inference
mechanism in HIP/SLEEK system is based on a new second-order bi-abductive entailment
with unknown predicates (a.k.a., second-order variables) by
constructing sound interpretations for them
during code verification~\cite{Loc:CAV:2014,Trinh:APLAS:2013}. This is achieved by
generating {\em relational assumptions} of the form
\code{\D_{\code{a}}\imply\D_{\code{c}}} that capture predefined 
analysis properties for the unknown
 predicates. The specification is inferred incrementally:
first with shape property and then other pure (non-shape) properties.
Typically, shape-based specification is
 inferred through  predicate definition derivation and
 normalization steps.
Pure-based specification is inferred through pure-property extension
and fixed point computation.

In the following, we first show our approach through
an example (Subsection \ref{shape.ex}). After that, we describe the second-order formalism
(Subsection \ref{shape.sobd}). Finally, we present the Hoare logic for
specification  inference (Subsection \ref{shape.veri}).


\subsection{Illustrative Example}\label{shape.ex}
\input{shape-ex}

\subsection{Second-Order Entailment Procedure}\label{shape.sobd}
\input{shape-ent}

\subsection{Specification Inference via Hoare-Style Rules}\label{shape.veri}
\input{shape-hoare}
